%% AMS-LaTeX Created with the Wolfram Language : www.wolfram.com

\documentclass{article}
\usepackage{amsmath, amssymb, graphics, setspace}

\newcommand{\mathsym}[1]{{}}
\newcommand{\unicode}[1]{{}}

\begin{document}

\title{Modeling Homework: ABB IRb - 7600 manipulator}
\author{}
\date{}
\maketitle

\begin{doublespace}
\noindent\(\fbox{$\text{Release the magic}$}\)
\end{doublespace}

\begin{doublespace}
\noindent\(\pmb{\text{AutoCollapse}[]\text{:=}(\text{If}[\text{$\$$FrontEnd}\text{=!=}\text{$\$$Failed},\text{SelectionMove}[\text{EvaluationNotebook}[],\text{All},\text{GeneratedCell}];}\\
\pmb{\text{FrontEndTokenExecute}[\text{{``}SelectionCloseUnselectedCells{''}}]])}\)
\end{doublespace}

\section*{Definitions}

\begin{doublespace}
\noindent\(\pmb{\text{Matrix$\mathcal{T}$}[\text{a$\_$},\alpha \_,\text{d$\_$},\theta \_]\text{:=}\{}\\
\pmb{\{\text{Cos}[\theta ], -\text{Sin}[\theta ], 0,\text{  }a\},}\\
\pmb{\{\text{Sin}[\theta ]*\text{Cos}[\alpha ],\text{Cos}[\theta ]*\text{Cos}[\alpha ], -\text{Sin}[\alpha ], -d*\text{Sin}[\alpha ]\},}\\
\pmb{\{\text{Sin}[\theta ]*\text{Sin}[\alpha ], \text{Cos}[\theta ]*\text{Sin}[\alpha ], \text{Cos}[\alpha ], d*\text{Cos}[\alpha ]\}, }\\
\pmb{\{0, 0, 0, 1\}}\\
\pmb{\}}\\
\pmb{\text{Link$\mathcal{T}$}[\text{i$\_$}]\text{:=}\text{Matrix$\mathcal{T}$}[\text{ToExpression}[\text{a}<>\text{ToString}[i-1]],\text{ToExpression}[\text{{``}$\alpha ${''}}<>\text{ToString}[i-1]],\text{ToExpression}[\text{d}<>\text{ToString}[i]],\text{ToExpression}[\text{{``}$\theta ${''}}<>\text{ToString}[i]]]}\\
\pmb{\text{Link$\mathcal{T}$}[1]\text{//}\text{MatrixForm}}\)
\end{doublespace}

\begin{doublespace}
\noindent\(\left(
\begin{array}{cccc}
 \text{Cos}[\text{$\theta $1}] & -\text{Sin}[\text{$\theta $1}] & 0 & \text{a0} \\
 \text{Cos}[\text{$\alpha $0}] \text{Sin}[\text{$\theta $1}] & \text{Cos}[\text{$\alpha $0}] \text{Cos}[\text{$\theta $1}] & -\text{Sin}[\text{$\alpha $0}] & -\text{d1} \text{Sin}[\text{$\alpha $0}] \\
 \text{Sin}[\text{$\alpha $0}] \text{Sin}[\text{$\theta $1}] & \text{Cos}[\text{$\theta $1}] \text{Sin}[\text{$\alpha $0}] & \text{Cos}[\text{$\alpha $0}] & \text{d1} \text{Cos}[\text{$\alpha $0}] \\
 0 & 0 & 0 & 1 \\
\end{array}
\right)\)
\end{doublespace}

\section*{Denavit-Hartenberg parameters for IRb-7600 manipulator}

\begin{doublespace}
\noindent\(\pmb{\text{LinkN}=6;\text{(*Number of links*)}}\)
\end{doublespace}

\begin{doublespace}
\noindent\(\pmb{\text{Constraints}\text{:=}\{}\\
\pmb{\text{a0}\to 0,\text{$\alpha $0}\to 0,\text{d1}\to 0 ,\text{(*Axis A*)}}\\
\pmb{\text{(*}\text{a1}\to \text{a1}, \text{*)}\text{$\alpha $1}\to \frac{3\pi \text{   }}{2}, \text{d2}\to  0,\text{(*Axis B*)}}\\
\pmb{\text{(*}\text{a2}\to \text{a2}, \text{*)} \text{$\alpha $2}\to 0 ,\text{d3}\to 0,\text{(*Axis C*)}}\\
\pmb{\text{(*}\text{a3}\to \text{a3}, \text{*)}\text{$\alpha $3}\to \frac{3\pi }{2},\text{(*}\text{d4}\to \text{d4}, \text{*)}\text{(*Axis D*)}}\\
\pmb{\text{a4}\to 0,\text{$\alpha $4}\to \frac{\pi }{2},\text{d5}\to 0,\text{(*Axis E*)}}\\
\pmb{\text{a5}\to 0,\text{$\alpha $5}\to \frac{3\pi }{2}\text{(*}, \text{d6}\to \text{d6}\text{*)}\text{(*Axis F*)}}\\
\pmb{\}}\\
\pmb{\text{NumericalConstraints}\text{:=}\text{Join}[\text{Constraints},\{}\\
\pmb{\text{a1}\to 410,\text{a2}\to 1075,\text{a3}\to 165,\text{d4}\to 1056,\text{d6}\to 250}\\
\pmb{\}]}\)
\end{doublespace}

\begin{doublespace}
\noindent\(\pmb{\text{(* Joint values for the initial pose shown in the diagram*)}}\\
\pmb{\text{InitialJoints}\text{:=}\{\text{$\theta $1}\to 0,\text{$\theta $2}\to 3\pi /2 ,\text{$\theta $3}\to 0,\text{$\theta $4}\to 0,\text{$\theta $5}\to 0,\text{$\theta $6}\to 0\}}\)
\end{doublespace}

\begin{doublespace}
\noindent\(\pmb{\text{(*Frame origin of coordinates from the ground frame in initial position*)}}\\
\pmb{\text{InitialFrameOrigin1}=\left(
\begin{array}{c}
 0 \\
 0 \\
 0 \\
 1 \\
\end{array}
\right);\text{InitialFrameOrigin2}=\left(
\begin{array}{c}
 410 \\
 0 \\
 0 \\
 1 \\
\end{array}
\right);\text{InitialFrameOrigin3}=\left(
\begin{array}{c}
 410 \\
 0 \\
 1075 \\
 1 \\
\end{array}
\right);}\\
\pmb{\text{InitialFrameOrigin4}=\left(
\begin{array}{c}
 410+1056 \\
 0 \\
 1075+165 \\
 1 \\
\end{array}
\right);\text{InitialFrameOrigin5}=\left(
\begin{array}{c}
 410+1056 \\
 0 \\
 1075+165 \\
 1 \\
\end{array}
\right);}\\
\pmb{\text{InitialFrameOrigin6}=\left(
\begin{array}{c}
 410+1056+250 \\
 0 \\
 1075+165 \\
 1 \\
\end{array}
\right);}\)
\end{doublespace}

\section*{Direct Kinematic problem}

\begin{doublespace}
\noindent\(\pmb{\mathcal{T}[\text{InitialFrame$\_$},\text{FinalFrame$\_$}]\text{:=}\text{Module}[\{i\},}\\
\pmb{\text{For}[i=\text{InitialFrame}+2;t=\text{Link$\mathcal{T}$}[\text{InitialFrame}+1],i\text{$<$=}\text{FinalFrame},i\text{++},t=t.\text{Link$\mathcal{T}$}[i];];\text{(*}\text{return}\text{*)}t}\\
\pmb{]}\\
\pmb{\text{IRb7600$\mathcal{T}$}[\text{InitialFrame$\_$},\text{FinalFrame$\_$}]\text{:=}\text{Map}[\text{Simplify},\mathcal{T}[\text{InitialFrame},\text{FinalFrame}]\text{/.}\text{Constraints},\{2\}]}\\
\pmb{\text{NumIRb7600$\mathcal{T}$}[\text{InitialFrame$\_$},\text{FinalFrame$\_$}]\text{:=}\text{Map}[\text{Simplify},\mathcal{T}[\text{InitialFrame},\text{FinalFrame}]\text{/.}\text{NumericalConstraints},\{2\}]}\\
\pmb{\text{IRb7600$\mathcal{T}$}[0,3]\text{//}\text{MatrixForm}}\)
\end{doublespace}

\begin{doublespace}
\noindent\(\left(
\begin{array}{cccc}
 \text{Cos}[\text{$\theta $1}] \text{Cos}[\text{$\theta $2}+\text{$\theta $3}] & -\text{Cos}[\text{$\theta $1}] \text{Sin}[\text{$\theta $2}+\text{$\theta $3}] & -\text{Sin}[\text{$\theta $1}] & \text{Cos}[\text{$\theta $1}] (\text{a1}+\text{a2} \text{Cos}[\text{$\theta $2}]) \\
 \text{Cos}[\text{$\theta $2}+\text{$\theta $3}] \text{Sin}[\text{$\theta $1}] & -\text{Sin}[\text{$\theta $1}] \text{Sin}[\text{$\theta $2}+\text{$\theta $3}] & \text{Cos}[\text{$\theta $1}] & (\text{a1}+\text{a2} \text{Cos}[\text{$\theta $2}]) \text{Sin}[\text{$\theta $1}] \\
 -\text{Sin}[\text{$\theta $2}+\text{$\theta $3}] & -\text{Cos}[\text{$\theta $2}+\text{$\theta $3}] & 0 & -\text{a2} \text{Sin}[\text{$\theta $2}] \\
 0 & 0 & 0 & 1 \\
\end{array}
\right)\)
\end{doublespace}

\begin{doublespace}
\noindent\(\pmb{\text{ShortForm} = \{\};}\\
\pmb{\text{For}[i=1,i\leq \text{LinkN},i\text{++},}\\
\pmb{\text{ShortForm} = \text{Append}[\text{ShortForm},\text{Sin}[\text{ToExpression}[\text{{``}$\theta ${''}}<>\text{ToString}[i]]]\to \text{Subscript}[s,i]];}\\
\pmb{\text{ShortForm} = \text{Append}[\text{ShortForm},\text{Cos}[\text{ToExpression}[\text{{``}$\theta ${''}}<>\text{ToString}[i]]]\to \text{Subscript}[c,i]];}\\
\pmb{]}\\
\pmb{\text{ShortForm} = \text{Append}[\text{ShortForm},\text{Sin}[\text{$\theta $2}+\text{$\theta $3}]\to \text{Subscript}[s,\text{{``}2+3{''}}]];}\\
\pmb{\text{ShortForm} = \text{Append}[\text{ShortForm},\text{Cos}[\text{$\theta $2}+\text{$\theta $3}]\to \text{Subscript}[c,\text{{``}2+3{''}}]];}\\
\pmb{\text{ShortForm} = \text{Join}\left[\text{ShortForm},\left\{\text{a1}\to a_1,\text{a2}\to a_2,\text{a3}\to a_3,\text{d4}\to d_4,\text{d6}\to d_6\right\}\right];}\)
\end{doublespace}

\begin{doublespace}
\noindent\(\pmb{\text{For}[i=1,i\leq \text{LinkN},i\text{++},}\\
\pmb{\text{Print}[\text{Subsuperscript}[\text{{``} {''}},i,0],\text{{``}$\mathcal{T}$={''}},}\\
\pmb{\text{MatrixForm}[\text{IRb7600$\mathcal{T}$}[0,i]\text{/.}\text{ShortForm}]}\\
\pmb{];}\\
\pmb{]}\)
\end{doublespace}

\noindent\(\text{Subsuperscript}[ ,1,0]\text{$\mathcal{T}$=}\left(
\begin{array}{cccc}
 c_1 & -s_1 & 0 & 0 \\
 s_1 & c_1 & 0 & 0 \\
 0 & 0 & 1 & 0 \\
 0 & 0 & 0 & 1 \\
\end{array}
\right)\)

\noindent\(\text{Subsuperscript}[ ,2,0]\text{$\mathcal{T}$=}\left(
\begin{array}{cccc}
 c_1 c_2 & -c_1 s_2 & -s_1 & a_1 c_1 \\
 c_2 s_1 & -s_1 s_2 & c_1 & a_1 s_1 \\
 -s_2 & -c_2 & 0 & 0 \\
 0 & 0 & 0 & 1 \\
\end{array}
\right)\)

\noindent\(\text{Subsuperscript}[ ,3,0]\text{$\mathcal{T}$=}\left(
\begin{array}{cccc}
 c_1 c_{\text{2+3}} & -c_1 s_{\text{2+3}} & -s_1 & c_1 \left(a_1+a_2 c_2\right) \\
 c_{\text{2+3}} s_1 & -s_1 s_{\text{2+3}} & c_1 & \left(a_1+a_2 c_2\right) s_1 \\
 -s_{\text{2+3}} & -c_{\text{2+3}} & 0 & -a_2 s_2 \\
 0 & 0 & 0 & 1 \\
\end{array}
\right)\)

\noindent\(\text{Subsuperscript}[ ,4,0]\text{$\mathcal{T}$=}\left(
\begin{array}{cccc}
 c_1 c_4 c_{\text{2+3}}+s_1 s_4 & c_4 s_1-c_1 c_{\text{2+3}} s_4 & -c_1 s_{\text{2+3}} & c_1 \left(a_1+a_2 c_2+a_3 c_{\text{2+3}}-d_4 s_{\text{2+3}}\right) \\
 c_2 c_3 c_4 s_1-c_4 s_1 s_2 s_3-c_1 s_4 & -c_1 c_4-c_{\text{2+3}} s_1 s_4 & -s_1 s_{\text{2+3}} & s_1 \left(a_1+a_2 c_2+a_3 c_{\text{2+3}}-d_4 s_{\text{2+3}}\right) \\
 -c_4 s_{\text{2+3}} & s_4 s_{\text{2+3}} & -c_{\text{2+3}} & -c_{\text{2+3}} d_4-a_2 s_2-a_3 s_{\text{2+3}} \\
 0 & 0 & 0 & 1 \\
\end{array}
\right)\)

\noindent\(\text{Subsuperscript}[ ,5,0]\text{$\mathcal{T}$=}\left(
\begin{array}{cccc}
 c_5 s_1 s_4+c_1 \left(c_4 c_5 c_{\text{2+3}}-s_5 s_{\text{2+3}}\right) & -s_1 s_4 s_5-c_1 \left(c_4 c_{\text{2+3}} s_5+c_5 s_{\text{2+3}}\right) & -c_4 s_1+c_1 c_{\text{2+3}} s_4 & c_1 \left(a_1+a_2 c_2+a_3 c_{\text{2+3}}-d_4 s_{\text{2+3}}\right) \\
 c_5 \left(c_2 c_3 c_4 s_1-c_4 s_1 s_2 s_3-c_1 s_4\right)-s_1 s_5 s_{\text{2+3}} & -c_2 c_5 s_1 s_3+\left(c_4 s_1 s_2 s_3+c_1 s_4\right) s_5-c_3 s_1 \left(c_5 s_2+c_2 c_4 s_5\right) & c_1 c_4+c_{\text{2+3}} s_1 s_4 & s_1 \left(a_1+a_2 c_2+a_3 c_{\text{2+3}}-d_4 s_{\text{2+3}}\right) \\
 -c_{\text{2+3}} s_5-c_4 c_5 s_{\text{2+3}} & s_2 \left(c_5 s_3+c_3 c_4 s_5\right)+c_2 \left(-c_3 c_5+c_4 s_3 s_5\right) & -s_4 s_{\text{2+3}} & -c_{\text{2+3}} d_4-a_2 s_2-a_3 s_{\text{2+3}} \\
 0 & 0 & 0 & 1 \\
\end{array}
\right)\)

\noindent\(\text{Subsuperscript}[ ,6,0]\text{$\mathcal{T}$=}\left(
\begin{array}{cccc}
 s_1 \left(c_5 c_6 s_4+c_4 s_6\right)+c_1 \left(c_{\text{2+3}} \left(c_4 c_5 c_6-s_4 s_6\right)-c_6 s_5 s_{\text{2+3}}\right) & c_6 \left(c_4 s_1-c_1 c_{\text{2+3}} s_4\right)-s_6 \left(c_5 s_1 s_4+c_1 \left(c_4 c_5 c_{\text{2+3}}-s_5 s_{\text{2+3}}\right)\right) & -s_1 s_4 s_5-c_1 \left(c_4 c_{\text{2+3}} s_5+c_5 s_{\text{2+3}}\right) & -d_6 s_1 s_4 s_5+c_1 \left(a_1+a_2 c_2+c_{\text{2+3}} \left(a_3-c_4 d_6 s_5\right)-d_4 s_{\text{2+3}}-c_5 d_6 s_{\text{2+3}}\right) \\
 -\left(c_1 c_4+c_{\text{2+3}} s_1 s_4\right) s_6+c_6 \left(c_5 \left(c_2 c_3 c_4 s_1-c_4 s_1 s_2 s_3-c_1 s_4\right)-s_1 s_5 s_{\text{2+3}}\right) & c_1 \left(-c_4 c_6+c_5 s_4 s_6\right)+s_1 \left(-c_6 c_{\text{2+3}} s_4+s_6 \left(-c_2 c_3 c_4 c_5+c_4 c_5 s_2 s_3+s_5 s_{\text{2+3}}\right)\right) & -c_2 c_5 s_1 s_3+\left(c_4 s_1 s_2 s_3+c_1 s_4\right) s_5-c_3 s_1 \left(c_5 s_2+c_2 c_4 s_5\right) & c_1 d_6 s_4 s_5+s_1 \left(a_1-c_3 \left(d_4+c_5 d_6\right) s_2-a_3 s_2 s_3+c_4 d_6 s_2 s_3 s_5+c_2 \left(a_2-\left(d_4+c_5 d_6\right) s_3+c_3 \left(a_3-c_4 d_6 s_5\right)\right)\right) \\
 -c_6 \left(c_3 \left(c_4 c_5 s_2+c_2 s_5\right)+s_3 \left(c_2 c_4 c_5-s_2 s_5\right)\right)+s_4 s_6 s_{\text{2+3}} & c_3 \left(c_6 s_2 s_4+\left(c_4 c_5 s_2+c_2 s_5\right) s_6\right)+s_3 \left(-s_2 s_5 s_6+c_2 \left(c_6 s_4+c_4 c_5 s_6\right)\right) & s_2 \left(c_5 s_3+c_3 c_4 s_5\right)+c_2 \left(-c_3 c_5+c_4 s_3 s_5\right) & -c_2 \left(c_3 \left(d_4+c_5 d_6\right)+s_3 \left(a_3-c_4 d_6 s_5\right)\right)+s_2 \left(-a_2+\left(d_4+c_5 d_6\right) s_3+c_3 \left(-a_3+c_4 d_6 s_5\right)\right) \\
 0 & 0 & 0 & 1 \\
\end{array}
\right)\)

\subsection*{Validation}

\begin{doublespace}
\noindent\(\pmb{\text{CheckDirectKinematic}[\text{link$\_$}]\text{:=}\text{Module}[\{\text{calculated},\text{known}\},}\\
\pmb{\text{calculated}=\text{NumIRb7600$\mathcal{T}$}[0,\text{link}]\text{/.}\text{InitialJoints};}\\
\pmb{\text{known}=\text{ToExpression}[\text{{``}InitialFrameOrigin{''}}<>\text{ToString}[\text{link}]]\text{(* Link origin from ground frame *)};}\\
\pmb{\text{(*}\text{                }P_0 = \mathcal{T}_n^0 x P_n\text{                }\text{*)}}\\
\pmb{\text{Print}[}\\
\pmb{\text{Subsuperscript}[\text{{``} {''}},i,0],\text{{``}$\mathcal{T}$={''}},\text{calculated}\text{//}\text{MatrixForm},\text{{``}; Check = {''}},}\\
\pmb{(\text{known}\text{//}\text{MatrixForm})==(\text{calculated}.\text{Transpose}[\{\{0,0,0,1\}\}]\text{(* Origin from the same axis*)}\text{//}\text{MatrixForm})}\\
\pmb{];}\\
\pmb{]}\\
\pmb{\text{For}[i=1,i\leq \text{LinkN},i\text{++},\text{CheckDirectKinematic}[i]]}\\
\pmb{\text{AutoCollapse}[]}\)
\end{doublespace}

\noindent\(\text{Subsuperscript}[ ,1,0]\text{$\mathcal{T}$=}\left(
\begin{array}{cccc}
 1 & 0 & 0 & 0 \\
 0 & 1 & 0 & 0 \\
 0 & 0 & 1 & 0 \\
 0 & 0 & 0 & 1 \\
\end{array}
\right)\text{; Check = }\text{True}\)

\noindent\(\text{Subsuperscript}[ ,2,0]\text{$\mathcal{T}$=}\left(
\begin{array}{cccc}
 0 & 1 & 0 & 410 \\
 0 & 0 & 1 & 0 \\
 1 & 0 & 0 & 0 \\
 0 & 0 & 0 & 1 \\
\end{array}
\right)\text{; Check = }\text{True}\)

\noindent\(\text{Subsuperscript}[ ,3,0]\text{$\mathcal{T}$=}\left(
\begin{array}{cccc}
 0 & 1 & 0 & 410 \\
 0 & 0 & 1 & 0 \\
 1 & 0 & 0 & 1075 \\
 0 & 0 & 0 & 1 \\
\end{array}
\right)\text{; Check = }\text{True}\)

\noindent\(\text{Subsuperscript}[ ,4,0]\text{$\mathcal{T}$=}\left(
\begin{array}{cccc}
 0 & 0 & 1 & 1466 \\
 0 & -1 & 0 & 0 \\
 1 & 0 & 0 & 1240 \\
 0 & 0 & 0 & 1 \\
\end{array}
\right)\text{; Check = }\text{True}\)

\noindent\(\text{Subsuperscript}[ ,5,0]\text{$\mathcal{T}$=}\left(
\begin{array}{cccc}
 0 & 1 & 0 & 1466 \\
 0 & 0 & 1 & 0 \\
 1 & 0 & 0 & 1240 \\
 0 & 0 & 0 & 1 \\
\end{array}
\right)\text{; Check = }\text{True}\)

\noindent\(\text{Subsuperscript}[ ,6,0]\text{$\mathcal{T}$=}\left(
\begin{array}{cccc}
 0 & 0 & 1 & 1716 \\
 0 & -1 & 0 & 0 \\
 1 & 0 & 0 & 1240 \\
 0 & 0 & 0 & 1 \\
\end{array}
\right)\text{; Check = }\text{True}\)

\section*{Inverse Kinematic problem}

\subsection*{Definitions}

\begin{doublespace}
\noindent\(\pmb{\text{For}[i=1,i\leq 3,i\text{++},}\\
\pmb{\text{For}[j=1,j\leq 3,j\text{++},}\\
\pmb{\text{ShortForm} = \text{Append}[\text{ShortForm},\text{ToExpression}[\text{r}<>\text{ToString}[i]<>\text{ToString}[j]]\to \text{Subscript}[r,\text{ToString}[i]<>\text{ToString}[i]]];}\\
\pmb{]}\\
\pmb{]}\\
\pmb{\text{ShortForm} = \text{Join}\left[\text{ShortForm},\left\{\text{px}\to p_x,\text{py}\to p_y,\text{pz}\to p_z\right\}\right];}\)
\end{doublespace}

\begin{doublespace}
\noindent\(\pmb{\text{$\mathcal{T}$d}=\left(
\begin{array}{cccc}
 \text{r11} & \text{r12} & \text{r13} & \text{px} \\
 \text{r21} & \text{r22} & \text{r23} & \text{py} \\
 \text{r31} & \text{r32} & \text{r33} & \text{pz} \\
 0 & 0 & 0 & 1 \\
\end{array}
\right);\text{(*}\text{$\mathcal{T}$d}=\left(
\begin{array}{cccc}
 r_{11} & r_{12} & r_{13} & p_x \\
 r_{21} & r_{22} & r_{23} & p_y \\
 r_{31} & r_{32} & r_{33} & p_z \\
 0 & 0 & 0 & 1 \\
\end{array}
\right);\text{*)}}\)
\end{doublespace}

\begin{doublespace}
\noindent\(\pmb{\text{SolveTan}[\text{eq$\_$},\text{var$\_$}]\text{:=}\text{Module}[\{\text{temp},x,\text{mapf},t\},}\\
\pmb{\text{temp}=\text{Flatten}\left[\text{Solve}\left[(\text{eq})\text{/.}\left\{\text{Tan}[\text{var}]\to x,\text{Sin}[\text{var}]\to  \sqrt{\frac{1}{1+x^2}},\text{Cos}[\text{var}]\to  \sqrt{\frac{x^2}{1+x^2}}\right\},x\right]\right];}\\
\pmb{t[\text{sol$\_$}]\text{:=}\text{Apply}[\text{ArcTan},\text{Reverse}[\text{NumeratorDenominator}[x\text{/.}\text{sol}]]];}\\
\pmb{\text{mapf}[\text{sol$\_$}]\text{:=}\{\text{var}\to t[\text{sol}]\text{(*},\text{var}\to \pi +t[\text{sol}]\text{*)}\};}\\
\pmb{\text{mapf}\text{/@}\text{temp}\text{//}\text{Flatten}}\\
\pmb{]}\)
\end{doublespace}

\begin{doublespace}
\noindent\(\pmb{\text{SolveSin}[\text{eq$\_$},\text{var$\_$}]\text{:=}\text{Module}[\{\text{temp},x,\text{mapf},t\},}\\
\pmb{\text{temp}=\text{Flatten}\left[\text{Solve}\left[(\text{eq})\text{/.}\left\{\text{Sin}[\text{var}]\to x,\text{Cos}[\text{var}]\to \sqrt{1-x^2},\text{Tan}[\text{var}]\to \frac{x}{\sqrt{1-x^2}}\right\},x\right]\right];}\\
\pmb{t[\text{sol$\_$}]\text{:=}\text{ArcTan}\left[\sqrt{1-x^2}\text{/.}\text{sol},x\text{/.}\text{sol}\right];}\\
\pmb{\text{mapf}[\text{sol$\_$}]\text{:=}\{\text{var}\to t[\text{sol}]\text{(*},\text{var}\to \pi +t[\text{sol}]\text{*)}\};}\\
\pmb{\text{mapf}\text{/@}\text{temp}\text{//}\text{Flatten}}\\
\pmb{]}\)
\end{doublespace}

\begin{doublespace}
\noindent\(\pmb{\text{SolveCos}[\text{eq$\_$},\text{var$\_$}]\text{:=}\text{Module}[\{\text{temp},x,\text{mapf},t\},}\\
\pmb{\text{temp}=\text{Flatten}\left[\text{Solve}\left[(\text{eq})\text{/.}\left\{\text{Cos}[\text{var}]\to x,\text{Sin}[\text{var}]\to \sqrt{1-x^2},\text{Tan}[\text{var}]\to \frac{\sqrt{1-x^2}}{x}\right\},x\right]\right];}\\
\pmb{t[\text{sol$\_$}]\text{:=}\text{ArcTan}\left[x\text{/.}\text{sol},\sqrt{1-x^2}\text{/.}\text{sol}\right];}\\
\pmb{\text{mapf}[\text{sol$\_$}]\text{:=}\{\text{var}\to t[\text{sol}]\text{(*},\text{var}\to \pi +t[\text{sol}]\text{*)}\};}\\
\pmb{\text{mapf}\text{/@}\text{temp}\text{//}\text{Flatten}}\\
\pmb{]}\)
\end{doublespace}

\subsection*{Development}

\begin{doublespace}
\noindent\(\pmb{\text{}}\)
\end{doublespace}

\subsubsection*{Solve \(\theta _1\) as a function of given parameters}

